
<template>
	<view class="uni-page-modal-5600">
		<!-- 表头样式 -->
		<view class="view-header">
			<view class="v-headStyle" v-for="(item,index) in head_styledef.form.items">
				<text class="txt_title" :style="{'width':item.labelWidth+'px'}">{{item.label}}：</text>
				<!-- 下拉框-单选 item.useDict?item.dict:item.selections-->
				<!-- <uni-data-select class="dv_select" v-if="item.name=='Select'" :class="item.disabled?'input-disabled':''"
					v-model="item.value" :localdata="item.dict" @change="onEnterChange(item)" :disabled="item.disabled"
					:clear="false"></uni-data-select> -->
				<uni-data-picker class="dv_select"  v-if="item.name=='Select'" :class="item.disabled?'input-disabled':''"
					v-model="item.value"  :localdata="item.dict" @change="onEnterChange(item)" :readonly="item.disabled" :clear-icon="false" :popup-title="item.label" ></uni-data-picker>				
				<view class="input-wrapper" v-if="item.name=='Input' || item.name=='InputNumber'">
					<text v-if="item.setting.prefix" class="uni-icon" :class="[item.setting.prefix]"
						@click="onEnterChange(item)">&#xe568;</text>
					<input class="uni-input" :class="item.disabled?'input-disabled':''"
						:type="item.name=='Input'?'text':'number'" v-model="item.value" :disabled="item.disabled"
						:placeholder="item.placeholder"
						:style="{'width':item.setting.prefix && item.setting.suffix?'78%':item.setting.prefix || item.setting.suffix?'87%':'96%'}"
						:focus="focusFieldId == item.fieldId" @focus="ontap(index,item)" @keyup.enter="onEnterChange(item)"
						@blur="onEnterChange(item)" />
					<text v-if="item.setting.suffix" class="uni-icon" :class="[item.setting.suffix]"
						@click="onEnterChange(item)">&#xe568;</text>
				</view>
			</view>
			
		</view>
		<view class="view-content">
			<!-- 码盘界面 -->
			<view v-if="param.Show_Welcom_Page==false"  class="uni-panel-content">
				<!-- 页签 -->
				<view class="dv-tab">
					<uni-segmented-control :current="current" :values="items" @clickItem="onClickItem"
						styleType="button">
					</uni-segmented-control>
				</view>
				<swiper class="view-tabpage" :current="current" @change="changeSwiper">
						<!-- 码盘界面 -->
					<swiper-item >
						<view class="uni-panel-content">
							<view class="view-tab-content" id="tabpanel">
								<image class="logo" v-if="detail1StyleDefList.length==0" src="../../images/mobox_log_200x40.png">
								</image>
								<div class="dv-panel" v-for="(style,ii) in detail1StyleDefList" @tap="onPanelClick(ii)"
									:id="'tabpanel'+style.form.htmlobjId"
									:class="style.form.htmlobjId==active_id?'bk-active':activelist[ii].active==true?'bk-active':''">
									<div class="dv-panel-input">
										<div class="dv-input" v-for="(item,index) in style.form.items">
											<!-- 普通布局 -->
											<view v-if="item.name!='Layout'">
												<text class="txt_title"
													:style="{'width':item.labelWidth+'px'}">{{item.label}}：</text>
												<span class="form-item-span" v-if="item.disabled">{{item.value}}</span>
												<input class="uni-input" v-if="!item.disabled"
													:type="item.name=='InputNumber'?'number':'text'" :value="item.value"
													:disabled="item.disabled" :placeholder="item.placeholder" />
											</view>
											<!-- 栅格布局 -->
											<uni-row class="demo-uni-row" v-if="item.name=='Layout'">
												<uni-col :span="24 / item.setting.col" v-for="(cols,key) in item.setting.colList">
													<view v-if="cols!=null">
														<text class="txt_title"
															:style="{'width':cols.labelWidth+'px'}">{{cols.label}}：</text>
														<span class="form-item-span" v-if="cols.disabled">{{cols.value}}</span>
														<input class="uni-input" v-if="!cols.disabled"
															:type="cols.name=='InputNumber'?'number':'text'" :value="cols.value"
															:disabled="cols.disabled" :placeholder="cols.placeholder" />
													</view>
												</uni-col>
											</uni-row>
										</div>
									</div>
									<div class="dv-panel-button">
										<checkbox-group v-if="param.Sub_Page[0].Select_Button==true">
											<label>
												<checkbox :value="style.SelBut_Checked" :checked="style.SelBut_Checked" />
												<!-- <text></text> -->
											</label>
										</checkbox-group>
										<!-- <button type="primary" @click="savaItem(ii)" v-if="param.Sub_Page[0].OK_Button==true">保存</Button> -->
										<button type="warn" @tap="delItem(ii)" v-if="param.Sub_Page[0].Del_Button==true" >删除</button>
									</div>
								</div>
							</view>
							<view class="view-bottom" v-if="param.Sub_Page[0].OK_Button==true">
								<button type="default" @tap="cancel" class="btn_cancel">取消</button>
								<button type="primary" @tap="ok" class="btn_add">确定</button>
							</view>
						</view>
					</swiper-item>
						<!-- 已码盘界面 -->
					<swiper-item>
						<view class="uni-panel-content">
							<view class="view-tab-content">
								<image class="logo" v-if="detail2StyleDefList.length==0" src="../../images/mobox_log_200x40.png">
								</image>
								<div class="dv-panel" v-for="(style,ii) in detail2StyleDefList">
									<div class="dv-panel-input">
										<div v-for="(item,index) in style.form.items">
											<!-- 普通布局 -->
											<view v-if="item.name!='Layout'">
												<text class="txt_title"
													:style="{'width':item.labelWidth+'px'}">{{item.label}}：</text>
												<span class="form-item-span">{{item.value}}</span>
											</view>
											<!-- 栅格布局 -->
											<uni-row class="demo-uni-row" v-if="item.name=='Layout'">
												<uni-col v-for="(cols,key) in item.setting.colList"
													:span="item.setting.spanList?item.setting.spanList[key]:24 / item.setting.col">
													<view v-if="cols!=null">
														<text class="txt_title"
															:style="{'width':cols.labelWidth+'px'}">{{cols.label}}：</text>
														<span class="form-item-span">{{cols.value}}</span>
													</view>
												</uni-col>
											</uni-row>
										</div>
									</div>
									<div class="dv-panel-button">
										<checkbox-group v-if="param.Sub_Page[1].Select_Button==true">
											<label>
												<checkbox :value="style.SelBut_Checked" :checked="style.SelBut_Checked" />
												<!-- <text></text> -->
											</label>
										</checkbox-group>
										<!-- <button type="primary" @click="savaDataObj(style,ii)" v-if="param.Sub_Page[1].OK_Button==true">保存</Button> -->
										<button type="warn" @tap="delDataObj(style,ii)"
											v-if="param.Sub_Page[1].Del_Button==true">删除</button>
									</div>
								</div>
							</view>
							<view class="view-bottom" v-if="param.Sub_Page[1].OK_Button==true"> <!--  -->
								<button type="default" @tap="cancel" class="btn_cancel">取消</button>
								<button type="primary" @tap="ok2" class="btn_add">确定</button>
							</view>
						</view>
					</swiper-item>
				</swiper>
			</view>
			<!-- 图文/文本 -->
			<view class="view-imagetext" v-if="param.Show_Welcom_Page==true">
				<div class="view-imagetext-uploadlist">
					<image :src="param.Welcome_Page.Img"
						:style="{'width':param.Welcome_Page.Width+'px','height':param.Welcome_Page.Height+'px'}">
					</image>
					<text class="txt-text"
						:style="{'color':param.Welcome_Page.Txt_Color,'font-size':param.Welcome_Page.Font_Size+'px','font-family':param.Welcome_Page.Font}">{{param.Welcome_Page.Text}}</Text>
				</div>
			</view>
		</view>
			<!-- <view class="view-bottom" v-if="current==0 && param.Sub_Page[0].OK_Button==true">
			<button type="default" @tap="cancel" class="btn_cancel">取消</button>
			<button type="primary" @tap="ok" class="btn_add">确定</button>
		</view>
		<view class="view-bottom" v-if="current==1 && param.Sub_Page[1].OK_Button==true">
			<button type="default" @tap="cancel" class="btn_cancel">取消</button>
			<button type="primary" @tap="ok2" class="btn_add">确定</button>
		</view> -->
	
	</view>
</template>

<script>
import Base64 from '../../components/js-base64/base64.js'
export default {
	modules: {
		Base64,
	},
	data() {
		return {
			title: '码盘',
			ClsID: 'CG_Detail',
			param: {},
			focusFieldId: "",
			focusOldFieldId: "",
			head_styledef: {
				form: {
					items: []
				}
			},
			detail1_styledef: {},
			detail1StyleDefList: [],
			detail2_styledef: {},
			detail2StyleDefList: [], //分页数据
			detail1ExtData: {},
			detail2ExtData: {}, //分页扩展数据
			// 分段器数据
			current: 0,
			Before_OK_Event: {},
			After_OK_Event: {},
			Before_Del_Event: {},
			After_Del_Event: {},
			items: [],
			active_id: '',
			activelist: [],
			selectAttrObj:{},
		};
	},
	onLoad(options) {
		// console.log(options);
		uni.setNavigationBarTitle({
			title: options.titlename
		}); //设置顶部标题 
		this.$data.title = options.titlename;
		this.$data.param = JSON.parse(options.param);
		// console.log(this.$data.param);
		//获取数据类的自定义表单参数
		this.Head_UIStyleGetInfo(this.$data.ClsID, this.$data.param.Input_UI_Style.ID);

		//加载初始界面
		if (this.$data.param.Show_Welcom_Page) {
			this.$data.param.Welcome_Page.Img = this.$data.param.Welcome_Page.Img.replace(/ /g, '+');
			this.$data.param.Welcome_Page.Width = parseInt(this.$data.param.Welcome_Page.Width);
			this.$data.param.Welcome_Page.Height = parseInt(this.$data.param.Welcome_Page.Height);
		}
		//加载Tab页签
		this.$data.items.push(this.$data.param.Sub_Page[0].Name);
		this.$data.items.push(this.$data.param.Sub_Page[1].Name);
		this.Detail1_UIstyleGetInfo(this.ClsID, this.$data.param.Sub_Page[0].UI_Style.ID);
		this.Detail2_UIstyleGetInfo(this.ClsID, this.$data.param.Sub_Page[1].UI_Style.ID);

		console.log(this.$data.param);
	},
		//页面初始化获取焦点
	methods: {
		setData: function(obj) {
			let that = this;
			let keys = [];
			let val, data;

			Object.keys(obj).forEach(function(key) {
				keys = key.split(".");
				val = obj[key];
				data = that.$data;
				keys.forEach(function(key2, index) {
					if (index + 1 == keys.length) {
						that.$set(data, key2, val);
					} else {
						if (!data[key2]) {
							that.$set(data, key2, {});
						}
					}
					data = data[key2];
				});
			});
		},
		changeSwiper(evt) {
			let index = evt.target.current || evt.detail.current;
			this.setData({
				current: index
			})
		},
		async Head_UIStyleGetInfo(class_id, style_id) { //获取自定义表单样式
			var $this = this;
			var dataInfo = {
				class_id: class_id,
				ui_style_id: style_id,
			};
			this.$store.dispatch('UIStyleGetInfo', dataInfo).then(ret => {
				// console.log(ret);
				if (ret.err_code == 0) {
					var styledef = "";
					if (ret.result.style_def) {
						//mobox2的style_def是json字符串
						styledef = ret.result.style_def.replace(/\\/g, "");
						//mobox3的style_def是base64字符串
						if (!ret.result.style_def.includes('"')) styledef = Base64.decode(ret.result
							.style_def);
					}
					$this.$data.head_styledef = ret.result.style_def ? JSON.parse(styledef) : {};
					// this.form = this.head_styledef.form.model;
					// console.log($this.$data.head_styledef);
					$this.$data.head_styledef.form.items.forEach(async (ele, index) => {
						if (ele.useDict == true) { //判断useDict是否使用字典
							await this.DictGetInfo(ele.bind.dict, index, 'mast');
						}
						if($this.focusFieldId == "")
						{
							if(ele.name=='Input' || ele.name=='InputNumber')
							{
								$this.setData({focusFieldId:ele.fieldId})
							}
						}
					
					});
				} else {
					uni.showModal({
						title: "错误1",
						content: ret.err_msg,
						showCancel: false,
						confirmText: "取消"
					});
				}
			}).catch(ex => {
				// console.log(ex);
				uni.showModal({
					title: "错误1.1",
					content: ex.errMsg,
					showCancel: false,
					confirmText: "取消"
				});
			});

		},
		async Detail1_UIstyleGetInfo(class_id, style_id) { //获取自定义表单样式
			var $this = this;
			var dataInfo = {
				class_id: class_id,
				ui_style_id: style_id,
			};
			this.$store.dispatch('UIStyleGetInfo', dataInfo).then(ret => {
				// console.log(ret);
				if (ret.err_code == 0) {
					var styledef = "";
					if (ret.result.style_def) {
						//mobox2的style_def是json字符串
						styledef = ret.result.style_def.replace(/\\/g, "");
						//mobox3的style_def是base64字符串
						if (!ret.result.style_def.includes('"')) styledef = Base64.decode(ret.result
							.style_def);
					}
					$this.$data.detail1_styledef = ret.result.style_def ? JSON.parse(styledef) : {};
					$this.$data.detail1_styledef.SelBut_Checked = true;
					// console.log($this.$data.detail1_styledef);
					// $this.$data.detail1StyleDefList.push($this.$data.detail1_styledef);
					// var aa = JSON.stringify(this.detail1_styledef);
					// $this.$data.detail1StyleDefList.push(JSON.parse(aa));
					// console.log($this.$data.detail1StyleDefList);
					$this.detail1_styledef.form.items.forEach(async (ele, index) => {
						if (ele.useDict == true) { //判断useDict是否使用字典
							await this.DictGetInfo(ele.bind.dict, index, 'sub');
						}
					});
				} else {
					uni.showModal({
						title: "错误2",
						content: ret.err_msg,
						showCancel: false,
						confirmText: "取消"
					});
				}
			}).catch(ex => {
				// console.log(ex);
				uni.showModal({
					title: "错误2.1",
					content: ex.errMsg,
					showCancel: false,
					confirmText: "取消"
				});
			});

		},
		async Detail2_UIstyleGetInfo(class_id, style_id) { //获取自定义表单样式
			var $this = this;
			var dataInfo = {
				class_id: class_id,
				ui_style_id: style_id,
			};
			this.$store.dispatch('UIStyleGetInfo', dataInfo).then(ret => {
				// console.log(ret);
				if (ret.err_code == 0) {
					var styledef = "";
					if (ret.result.style_def) {
						//mobox2的style_def是json字符串
						styledef = ret.result.style_def.replace(/\\/g, "");
						//mobox3的style_def是base64字符串
						if (!ret.result.style_def.includes('"')) styledef = Base64.decode(ret.result
							.style_def);
					}
					$this.$data.detail2_styledef = ret.result.style_def ? JSON.parse(styledef) : {};
					$this.$data.detail2_styledef.SelBut_Checked = true;
					// console.log($this.$data.detail2_styledef);

				} else {
					uni.showModal({
						title: "错误3",
						content: ret.err_msg,
						showCancel: false,
						confirmText: "取消"
					});
				}
			}).catch(ex => {
				// console.log(ex);
				uni.showModal({
					title: "错误3.1",
					content: ex.errMsg,
					showCancel: false,
					confirmText: "取消"
				});
			});

		},
		async DictGetInfo(dict, index, type) { //Mobox3得到得到字典信息字典项列表
			this.data = [];
			var $this = this;
			var dataInfo = {
				dict_id: dict.id,
				dict_name: dict.name
			};
			// console.log(dataInfo);
			this.$store.dispatch('DictGetInfo', dataInfo).then(async (success) => {
				console.log(success);
				if (success.err_code == 0) {
					var list = [];
					var itemName = '';
					success.result.dict_item_list.forEach((item) => {
						if (item.is_default == '1')
							itemName = item.name;
						list.push({
							text: item.value,
							value: item.name,
						});
					});

					if (type == 'mast') { //有默认值，显示默认值
						if (itemName) {
							$this.head_styledef.form.items[index].value = itemName;
							var attr = $this.head_styledef.form.items[index].fieldId;
							$this.head_styledef.form.model[attr] = itemName;
						}
						$this.head_styledef.form.items[index].dict = list;
						var head_styledef = JSON.parse(JSON.stringify($this.head_styledef));
						$this.head_styledef = [];
						$this.head_styledef = head_styledef;
						// console.log($this.head_styledef);
					} else {
						if (itemName) {
							$this.detail1_styledef.form.items[index].value = itemName;
							var attr = $this.detail1_styledef.form.items[index].fieldId;
							$this.detail1_styledef.form.model[attr] = itemName;
						}
						$this.detail1_styledef.form.items[index].dict = list;
						var detail1_styledef = JSON.parse(JSON.stringify($this.detail1_styledef));
						$this.detail1_styledef = [];
						$this.detail1_styledef = detail1_styledef;
						// console.log($this.$data.detail1_styledef);
					}

				} else {
					uni.showModal({
						title: "错误3.1",
						content: success.err_msg,
						showCancel: false,
						confirmText: "取消"
					});
				}
			}).catch(ex => {
				// console.log(ex);
				uni.showModal({
					title: "错误3",
					content: ex.errMsg,
					showCancel: false,
					confirmText: "取消"
				});
			});
		},

		ontap(index,item) { //扫码功能
			// var $ele = e;
			//console.log(e.target)
			this.focusOldFieldId = item.fieldId
			getApp().onScan((result) => {
				console.log(result.decodedata);
				item.value = result.decodedata;
				// uni.hideKeyboard();
				var $this = this;

				// if(item.value=='B61DF51DD50645CEB9D152DD77D2466A'){
				// 	this.active_id = 'B61DF51DD50645CEB9D152DD77D2466A';
				// 	// var target = uni.createSelectorQuery().select('#B61DF51DD50645CEB9D152DD77D2466A');
				// 	uni.createSelectorQuery()
				// 	    .select("#tabpanel")//对应外层节点
				// 	    .boundingClientRect((container) => {
				// 	        uni.createSelectorQuery()
				// 	        .select("#B61DF51DD50645CEB9D152DD77D2466A")//目标节点
				// 	        .boundingClientRect((target) => {
				// 	            uni.pageScrollTo({
				// 	            scrollTop: target.top - container.top,//滚动到实际距离是元素距离顶部的距离减去最外层盒子的滚动距离
				// 	            });
				// 	        })
				// 	        .exec();
				// 	    })
				// 	    .exec();
				// }
				//console.log(item);
				if (item.oldvalue != item.value) {
					item.oldvalue = item.value;
					var attr = item.fieldId;
					this.head_styledef.form.model[attr] = item.value;
					var onChangeEvent = item.bind.onChangeEvent; //内容变化后事件
					var onSuffixClickCallbackEvent = item.bind.onSuffixClickCallbackEvent; //后图标点击事件
					var onSuffixClickEvent = item.bind.onSuffixClickEvent; //后图标点击回调
					var isflag = false;

					if (onChangeEvent.id) { //内容变化后事件
						$this.onChange(onChangeEvent);
					}
					if (item.value) { //第一个输入框不为空
					 //初始化，下个输入框focus属性
						const curIndex =  $this.head_styledef.form.items.findIndex((ele, index2, arr) => {
						  return (ele.name=='Input' || ele.name=='InputNumber')  && index2 > index;
						})
						if(curIndex > -1){
							$this.setData({focusFieldId: $this.head_styledef.form.items[curIndex].fieldId})
						}
						// setTimeout(function() {
						// 	uni.hideKeyboard();
						// }, 1000);
			
					}
					// if(onSuffixClickCallbackEvent.id){   //后图标点击事件
					//   this.onSuffixClick(onSuffixClickCallbackEvent);
					// }
					// if(onSuffixClickEvent.id){   //后图标点击回调
					//   this.onSuffixClickCallback(onSuffixClickEvent);
					// }
				}
			})
		},
		onEnterChange(item) { //回车，点击按钮，取消节点事件
			// console.log(item);
			if (item.oldvalue != item.value) {
				item.oldvalue = item.value;
				var attr = item.fieldId;
				this.head_styledef.form.model[attr] = item.value;
				var onChangeEvent = item.bind.onChangeEvent; //内容变化后事件
				var onSuffixClickCallbackEvent = item.bind.onSuffixClickCallbackEvent; //后图标点击事件
				var onSuffixClickEvent = item.bind.onSuffixClickEvent; //后图标点击回调
				var isflag = false;

				if (onChangeEvent.id) { //内容变化后事件
					this.onChange(onChangeEvent);
				}
				// if(onSuffixClickCallbackEvent.id){   //后图标点击事件
				//   this.onSuffixClick(onSuffixClickCallbackEvent);
				// }
				// if(onSuffixClickEvent.id){   //后图标点击回调
				//   this.onSuffixClickCallback(onSuffixClickEvent);
				// }
			}
		},
		getDetailAttrList(list, selectButton) {
			const detailAttrList = [];
			list.forEach(style => {
				var detail_attr = {};
				style.form.items.forEach(item => {
					if (item.name == "Layout") { //判断是否是栅栏格式
						item.setting.colList.forEach(cols => {
							if (cols != null) detail_attr[cols.fieldId] = cols.value;
						});
					} else
						detail_attr[item.fieldId] = item.value;
				});

				detail_attr['id'] = style.form.objId;
				if (selectButton == true) { //判断选择按钮是否为true
					if (style.SelBut_Checked == true)
						detailAttrList.push(detail_attr);
				} else
					detailAttrList.push(detail_attr);
			});
			// console.log(detailAttrList);
			//获取正在码盘里没有显示的字段
			list.forEach(style => {
				style.form.attrs.forEach(attr => {
					for (var key in detailAttrList) {
						if (style.form.objId == detailAttrList[key]['id']) {
							var keys = Object.keys(detailAttrList[key]);
							var isflag = true;
							keys.forEach((ele) => {
								if (ele == attr.attr) isflag = false;
							});
							if (isflag) {
								detailAttrList[attr.attr] = attr.value;
							}
						}
					}
				});
			});

			const jsonlist = [];
			detailAttrList.forEach(attr => {
				jsonlist.push({
					id: attr["id"]|| "",
					attrs: Object.keys(attr).map((a) => ({
						attr: a,
						value: attr[a] || "",
					})).filter((a)=>{return a.attr != "id"})
				});
			});
			return jsonlist;
		},
		// 内容变化后事件
		async onChange(event) {
			try {
				if (event.id) {

					//获取表头属性
					var head_attr = {};
					this.head_styledef.form.items.forEach(item => {
						head_attr[item.fieldId] = item.value;
					});
					var obj_attr = this.head_styledef.form.model;
					// console.log(obj_attr);
					var input_param = Base64.encode(
						JSON.stringify(
							Object.keys(head_attr).map((a) => ({
								attr: a,
								value: head_attr[a] || "",
							}))
						)
					);
					var $this = this;
					const jsonList = []
					const itemlist1= $this.getDetailAttrList($this.detail1StyleDefList,$this.param.Sub_Page[0].Select_Button)
					const itemlist2= $this.getDetailAttrList($this.detail2StyleDefList,$this.param.Sub_Page[1].Select_Button)
					
					jsonList.push({page_name:$this.param.Sub_Page[0].Name,item_list:itemlist1,ext_data:$this.detail1ExtData})
					jsonList.push({page_name:$this.param.Sub_Page[1].Name,item_list:itemlist2,ext_data:$this.detail2ExtData})
					const data_json = Base64.encode(
						JSON.stringify(jsonList)
					);
					var dataInfo = {
						ed_type: 0,
						start_transaction: true,
						class_id: this.$data.head_styledef.form.clsId,
						class_name: '',
						event_id: event.id,
						event_name: '',
						data_obj_id: '',
						obj_attr: obj_attr,
						prj_id: '',
						ref_cls_id: '',
						rel_obj_id: '',
						user_login: '',
						data_json: data_json,
						compose_info: '',
						ext_info: '',
						global_attr: '',
						input_param: input_param,
					};
					this.$store.dispatch('runCustomEvent', dataInfo).then(ret => {
						// console.log(ret);
						if (ret.err_code == 0) {
							var result = ret.result;
							if (result.ret != 0) {
								var tip = result.err_info ? typeof result.err_info == 'string' ? result
									.err_info : result.err_info.join('<br/>') : '';
								if (result.ret == 801) uni.showModal({
									title: '提示',
									content: tip,
									showCancel: false,
									confirmText: "取消"
								});
								else uni.showModal({
									title: '提示',
									content: tip + ',提示:' + result.ret,
									showCancel: false,
									confirmText: "取消"
								});
								return false;
							} else {
								var tip = result.info ? typeof result.info == 'string' ? result.info :
									result.info.join('<br/>') : '';
								if (tip) uni.showModal({
									title: '提示',
									content: tip,
									showCancel: false,
									confirmText: "取消"
								});

								if (result.result_type == 0 && result.action) {
									result.action.forEach(item => {
										if (item.action_type == "insert_subtable_page_row") { //码盘中
											$this.$data.param.Show_Welcom_Page = false;
											var value = item.value;
											$this.viewAceionRow(value);
										} else if (item.action_type ==
											"set_subtable_page_content") { //已码盘
											$this.$data.param.Show_Welcom_Page = false;
											var value = item.value;
											if (value.clear_confirm != false && value.clear == true 
												&& $this.$data.detail1StyleDefList.length > 0 
												&& value.page_name == $this.$data.param.Sub_Page[0].Name
												) { //判断是否清空页签内容,正在码盘是否有数据
												uni.showModal({
													title: '提示',
													content: '系统检测到有正在码盘中的货品，继续操作会清空，是否继续？',
													success: function(res) {
														if (res.confirm) {
															$this.$data
																.detail1StyleDefList = [];
															$this.viewAceionContent(
																value);
														} else if (res.cancel) {
															$this.$data
																.detail1StyleDefList = [];
															$this.viewAceionContent(
																value);
														}
													}
												});
											} else {
												if (value.page_name == $this.$data.param.Sub_Page[
														0].Name) { //判断返回的action的page_name是否是待分拣
													$this.$data.detail1StyleDefList = [];
												} else {
													$this.$data.detail2StyleDefList = [];
												}
												$this.viewAceionContent(value);
											}
										} else if (item.action_type ==
											"select_subtable_page_row") {
											// value = {"page_name":"码盘中", "row":{"id":"xx"}}
											var value = item.value;
											$this.detail1StyleDefList.forEach(ele => {
												$this.activelist[index].active = false;
												if (ele.form.objId == value.row.id) {
													ele.SelBut_Checked = true;
													$this.active_id = ele.form.htmlobjId;
													//自动滚动到指定元素
													uni.createSelectorQuery()
														.select("#tabpanel") //对应外层节点
														.boundingClientRect((
														container) => {
															uni.createSelectorQuery()
																.select("#tabpanel" +
																	ele.form.htmlobjId
																	) //目标节点
																.boundingClientRect((
																	target) => {
																	uni.pageScrollTo({
																		scrollTop: target
																			.top -
																			container
																			.top, //滚动到实际距离是元素距离顶部的距离减去最外层盒子的滚动距离
																	});
																})
																.exec();
														})
														.exec();
												}
											});
										}  else if(item.action_type == "remove_subtable_page_row"){  //清除面板中指定id的数据
											var value = item.value;
											if(value.page_name == $this.param.Sub_Page[0].Name){ //判断返回的action的page_name是否是待分拣
												//清除面板中指定id的数据
												value.row.forEach(row=>{
													$this.$data.detail1StyleDefList.forEach((ele,index)=>{
														if(ele.form.objId == row.id){
														  $this.$data.detail1StyleDefList.splice(index,1); 
														}
													});
												});
											}
										} 
										else if (item.action_type == "set_subtable_page_row") { 
											$this.viewActionSetRow( item.value)
											
										} else if (item.action_type == "set_subtable_page_ext_data") {
											var value = item.value;
											if (value.page_name == $this.$data.param.Sub_Page[0].Name) { //判断返回的action的page_name是否是待分拣
												$this.setData({detail1ExtData:value.ext_data})
											} else if (value.page_name == $this.$data.param.Sub_Page[1].Name) {
												$this.setData({detail2ExtData:value.ext_data})
											}
										}
										else if (item.action_type == "clear_subpage_rows") {
											var value = item.value;
											if (value.page_name == $this.$data.param.Sub_Page[0].Name) { //判断返回的action的page_name是否是待分拣
												$this.setData({detail1StyleDefList:[],detail1ExtData:{}})
											} else if (value.page_name == $this.$data.param.Sub_Page[1].Name) {
												$this.setData({detail2StyleDefList:[],detail2ExtData:{}})
											}
										}
										else if (item.action_type == "set_dlg_current_edit_attr") {
											if($this.focusOldFieldId == item.value)
											{
												$this.setData({focusFieldId: ""})
											}
											else{
												$this.setData({focusFieldId:$this.focusOldFieldId})	
											}
											$this.$nextTick(()=> {
												$this.setData({focusFieldId:item.value})
											});
										}
										else if (item.action_type == "set_dlg_attr") {
											// value = {"attr":"xxx", "value":"xxx"}
											var data = item.value;
											$this.$data.head_styledef.form.items.forEach(async (
												ele, index) => {
												data.forEach(async (ele2, index) => {
													if (ele.fieldId == ele2
														.attr) {
														ele.value = ele2
															.value;
													}
												});
											});
										}
									});
								} else {
									// this.detail2StyleDefList=[];
									if (result.info) {
										uni.showModal({
											title: "错误4.3",
											content: result.info,
											showCancel: false,
											confirmText: "取消"
										});
									}
								}
							}

						} else {
							uni.showModal({
								title: "错误4",
								content: ret.err_msg,
								showCancel: false,
								confirmText: "取消"
							});
						}
					}).catch(ex => {
						// console.log(ex);
						uni.showModal({
							title: "错误4.1",
							content: ex.errMsg,
							showCancel: false,
							confirmText: "取消"
						});
					});
				}
			} catch (ex) {
				var tip = typeof ex == "string" ? ex : ex.message;
				uni.showModal({
					title: "错误4.2",
					content: "执行“内容变化后”事件失败：" + tip,
					showCancel: false,
					confirmText: "取消"
				});

			}
		},
		operationNumber(value1, value2,operation){
			var number1 = 0
			var number2 =0
			if(value1)
				number1 =  parseInt(value1)
			if(value2)	
				number2 =  parseInt(value2)
			if(operation == "+")
			{
				return number1 + number2
			}
			else if(operation == "-")
			{
				return number1 - number2
			}
			else if(operation == "*")
			{
				return number1 * number2
			}
			else if(operation == "/")
			{
				if(number2)
					return number1 / number2
				else
					return number1 
			}
			else return number2 
		},
		
		//更新分页签中的列表项内容
		viewActionSetRow(value) {
			const $this = this
			var detailStyleDefList = []
			if(value.page_name == $this.$data.param.Sub_Page[1].Name)
			{
				detailStyleDefList = $this.$data.detail2StyleDefList
			}
			else if(value.page_name == $this.$data.param.Sub_Page[0].Name)
			{
				detailStyleDefList =$this.$data.detail1StyleDefList
			}
			detailStyleDefList.forEach(ele=>{
				value.row.forEach((rowData) => {
					if(ele.form.objId == rowData.id){
						rowData.attrs.forEach(attr=>{
							ele.form.items.forEach(ele2=>{
								if(ele2.name!='Layout'){
								  if(ele2.fieldId == attr.attr){
										ele2.value =$this.operationNumber(ele2.value,attr.value,attr.operation)
								  }
								} else if(ele2.name=='Layout'){
								  ele2.setting.colList.forEach(col=>{
									if(col)
									{
									  if(col.fieldId == attr.attr) 
									  {
										col.value =$this.operationNumber(col.value,attr.value,attr.operation)
									  }
									}
								  })
								}
							});
						});
					}
				})	
			});
			if(value.page_name == $this.$data.param.Sub_Page[1].Name)
			{
				$this.setData({detail2StyleDefList:detailStyleDefList})
			}
			else if(value.page_name == $this.$data.param.Sub_Page[0].Name)
			{
				 $this.setData({detail1StyleDefList:detailStyleDefList})
			}
			
		},
		//加载正在码盘内容
		viewAceionRow(data, type) {
			// console.log(data);
			if (JSON.stringify(data.row) == '{}') {
				return;
			}
			data.row.forEach(row => {
				var styleStr = JSON.stringify(this.$data.detail1_styledef);
				if (type) { //确定后脚本进入加载已分拣数据
					styleStr = JSON.stringify(this.$data.detail2_styledef);
				} else {
					if (data.page_name == this.$data.param.Sub_Page[1].Name) { //判断返回的action的page_name是否是已分拣
						styleStr = JSON.stringify(this.$data.detail2_styledef); //待分拣
					}
				}
				var detailStyle = JSON.parse(styleStr);
				detailStyle.form.objId = row.id;
				detailStyle.form.htmlobjId = row.id ? row.id.replace(/-/g, '').replace('{', '').replace('}',
					'') : 'null';
				detailStyle.form.attrs = row.attrs;
				row.attrs.forEach(attr => {
					detailStyle.form.items.forEach(ele => {
						if (ele.name != 'Layout') {
							if (ele.fieldId == attr.attr) ele.value = attr.value;
						} else if (ele.name == 'Layout') {
							ele.setting.colList.forEach(col => {
								if (col) {
									if (col.fieldId == attr.attr) col.value = attr
										.value;
								}
							});
						}
					});
				});

				if (type) { //确定后脚本进入加载已分拣数据
					this.$data.detail2StyleDefList.push(detailStyle);
					// console.log(this.$data.detail2StyleDefList);
				} else {
					if (data.page_name == this.$data.param.Sub_Page[1].Name) { //判断返回的action的page_name是否是已分拣
						this.$data.detail2StyleDefList.push(detailStyle);
						// console.log(this.$data.detail2StyleDefList);
					} else {
						this.$data.detail1StyleDefList.push(detailStyle);
						this.activelist.push({
							active: false
						});
						// console.log(this.$data.detail1StyleDefList);
					}
				}
			});
		},
		//加载已码盘内容
		viewAceionContent(data) {
			var $this = this;
			if (data.page_name == $this.param.Sub_Page[0].Name) {
				$this.detail1ExtData = data.ext_data ||{}
			}
			else if (data.page_name == $this.param.Sub_Page[1].Name) {
				$this.detail2ExtData = data.ext_data||{}
			} 
			if (JSON.stringify(data.content) == '{}') {
				return;
			}
			data.content.forEach(cont => {
				var styleStr = JSON.stringify($this.$data.detail2_styledef);
				if (data.page_name == $this.$data.param.Sub_Page[0].Name) { //判断返回的action的page_name是否是码盘中
					styleStr = JSON.stringify($this.$data.detail1_styledef); //码盘中
				}
				var detailStyle = JSON.parse(styleStr);
				detailStyle.SelBut_Checked = data.checkbox ?? true;
				detailStyle.form.objId = cont.id;
				detailStyle.form.htmlobjId = cont.id ? cont.id.replace(/-/g, '').replace('{', '').replace('}',
					'') : 'null';
				detailStyle.form.attrs = cont.attrs;
				cont.attrs.forEach(attr => {
					detailStyle.form.items.forEach(ele => {
						if (ele.name != 'Layout') {
							if (ele.fieldId == attr.attr) ele.value = attr.value;
						} else if (ele.name == 'Layout') {
							ele.setting.colList.forEach(col => {
								if (col) {
									if (col.fieldId == attr.attr) col.value = attr
										.value;
								}
							});
						}
					});
				});
				if (data.page_name == $this.$data.param.Sub_Page[0].Name) { //判断返回的action的page_name是否是待分拣
					//如果 clear = false 则不需要清除，根据id判断是否存在，不存在插入到页面，如果存在用新的属性覆盖
					if (data.clear == false) {
						var isflag = true;
						$this.detail1StyleDefList.forEach((style, index) => {
							if (style.form.objId == detailStyle.form.objId) {
								cont.attrs.forEach(attr => {
									style.form.items.forEach(ele => {
										if (ele.name != 'Layout') {
											if (ele.fieldId == attr.attr) ele.value =
												attr.value;
										} else if (ele.name == 'Layout') {
											ele.setting.colList.forEach(col => {
												if (col) {
													if (col.fieldId == attr
														.attr) col.value = attr
														.value;
												}
											});
										}
									});
								});
								isflag = false;
							}
						});
						if (isflag) $this.detail1StyleDefList.push(detailStyle); //待分拣
					} else {
						$this.detail1StyleDefList.push(detailStyle); //待分拣
					}
					$this.activelist.push({
						active: false
					});
					// console.log($this.$data.detail1StyleDefList);
				} else {
					if (data.clear == false) {
						//如果 clear = false 则不需要清除，根据id判断是否存在，不存在插入到页面，如果存在用新的属性覆盖
						var isflag = true;
						$this.detail2StyleDefList.forEach((style, index) => {
							if (style.form.objId == detailStyle.form.objId) {
								cont.attrs.forEach(attr => {
									style.form.items.forEach(ele => {
										if (ele.name != 'Layout') {
											if (ele.fieldId == attr.attr) ele.value =
												attr.value;
										} else if (ele.name == 'Layout') {
											ele.setting.colList.forEach(col => {
												if (col) {
													if (col.fieldId == attr
														.attr) col.value = attr
														.value;
												}
											});
										}
									});
								});
								isflag = false;
							}
						});
						if (isflag) $this.detail2StyleDefList.push(detailStyle); //已分拣
					} else {
						$this.detail2StyleDefList.push(detailStyle); //已分拣
					}
					// console.log($this.$data.detail2StyleDefList);
				}
			});
		
		

		},
		onClickItem(e) { //选择页签
			// console.log(e);
			this.current = e.currentIndex
		},
		onDetail1EnterChange(item) { //码盘中样式回车事件
			console.log(item);
		},
		delItem(index) { //删除码盘中样式面板
		
		   //删除码盘中样式面板
		  this.Before_Del_Event = this.param.Sub_Page[0].Before_Delete;
		  this.After_Del_Event = this.param.Sub_Page[0].After_Delete;
		  const style = this.detail1StyleDefList[index];
		  //删除码盘中样式面板
		  this.detail1StyleDefList.splice(index, 1);
		  if (this.Before_Del_Event?.ID)
			//是否有删除前事件
			this.del(style, this.Before_Del_Event);
		  else if (this.After_Del_Event?.ID)
			//是否有删除后事件
			this.del(style, this.After_Del_Event);
		},
		delDataObj(style, index) { //删除已码盘数
			// console.log(style);
			
			$this.Before_Del_Event = $this.param.Sub_Page[0].Before_Delete;
			$this.After_Del_Event = $this.param.Sub_Page[0].After_Delete;
			
			var $this = this;
			uni.showModal({
				title: '提示',
				content: '确定删除该已码盘数据！',
				success: function(res) {
					if (res.confirm) {
						var objID = style.form.objId;
						if (!style.form.objId.includes('{')) objID = '{' + style.form.objId + '}';

						var dataInfo = {
							class_id: style.form.clsId,
							class_name: '',
							obj_id: objID
						};
						// console.log(dataInfo);
						$this.$store.dispatch('dataObjDel', dataInfo).then(ret => {
							// console.log(ret);
							if (ret.err_code == 0) {
							const style = $this.detail2StyleDefList[index];
							$this.detail2StyleDefList.splice(index, 1); 
							if ($this.Before_Del_Event?.ID)
							//是否有删除前事件
								$this.del2(style, $this.Before_Del_Event);
							else if ($this.After_Del_Event?.ID)
							//是否有删除后事件
								$this.del2(style, $this.After_Del_Event);
								uni.showModal({
									title: "提示",
									content: "删除成功！",
									showCancel: false,
									confirmText: "取消"
								});
								

							} else {
								uni.showModal({
									title: "错误5",
									content: ret.err_msg,
									showCancel: false,
									confirmText: "取消"
								});
							}
						}).catch(ex => {
							// console.log(ex);
							uni.showModal({
								title: "错误5.1",
								content: ex.errMsg,
								showCancel: false,
								confirmText: "取消"
							});
						});
					} else if (res.cancel) {

					}
				}
			});

		},
		async del(style, event) {
	  //获取表头属性
			var head_attr = {};
			this.$data.head_styledef.form.items.forEach(item => {
			  head_attr[item.fieldId] = item.value;
			});
			// console.log(head_attr);
			//获取正在分拣属性
		  var detailAttrList = [];
		  var detail_attr={};
		  style.form.items.forEach(item => {
			if(item.name == "Layout"){  //判断是否是栅栏格式
			  item.setting.colList.forEach(cols => {
				if(cols!=null) detail_attr[cols.fieldId] = cols.value;
			  });
			}else
			  detail_attr[item.fieldId] = item.value;
		  });
		  
		 detail_attr['id'] = style.form.objId;
		  if($this.param.Sub_Page[0].Select_Button==true){ //判断选择按钮是否为true
			if(style.SelBut_Checked==true) 
			  detailAttrList.push(detail_attr);
		  } else 
			detailAttrList.push(detail_attr);

			// console.log(detailAttrList);
			//获取正在分拣里没有显示的字段
		  style.form.attrs.forEach(attr => {
			for(var key in detailAttrList){
			  if(style.form.objId == detailAttrList[key]['id']){
				var keys = Object.keys(detailAttrList[key]);
				var isflag = true;
				keys.forEach((ele) => {
					if(ele == attr.attr) isflag = false;
				});
				if(isflag) {
					detailAttrList[attr.attr] = attr.value;
				}
			  }
			}
		  });
			var input_param = Base64.encode(
				JSON.stringify(
				  Object.keys(head_attr).map((a) => ({
					attr: a,
					value: head_attr[a] || "",
				  }))
				)
			);
			 var jsonlist=[];
			detailAttrList.forEach(attr=>{
				jsonlist.push({
				  id:attr["id"]|| "",
				  attrs: Object.keys(attr).map((a) => ({
					attr: a,
					value: attr[a] || "",
				  })).filter((a)=>{return a.attr != "id"})
				});
			});
			// console.log(jsonlist);
			const list = []
			list.push({page_name:$this.param.Sub_Page[0].Name,item_list:jsonlist,ext_data:$this.detail1ExtData})
			$this.runCustomEvent(event,input_param,list,'1');
		},
		
		async del2(style, event) {
			 //获取表头属性
			var head_attr = {};
			this.$data.head_styledef.form.items.forEach(item => {
			  head_attr[item.fieldId] = item.value;
			});
			// console.log(head_attr);
			//获取已分拣属性
			var detailAttrList = [];
			var detail_attr={};
			style.form.items.forEach(item => {
			if(item.name == "Layout"){  //判断是否是栅栏格式
				item.setting.colList.forEach(cols => {
				if(cols!=null) detail_attr[cols.fieldId] = cols.value;
			  });
			}else
				detail_attr[item.fieldId] = item.value;
			});
			  
			detail_attr['id'] = style.form.objId;
			if($this.param.Sub_Page[1].Select_Button==true){ //判断选择按钮是否为true
				if(style.SelBut_Checked==true) 
					detailAttrList.push(detail_attr);
			} else 
				detailAttrList.push(detail_attr);
			//获取已分拣里没有显示的字段
			style.form.attrs.forEach(attr => {
				for(var key in detailAttrList){
					if(style.form.objId == detailAttrList[key]['id']){
					var keys = Object.keys(detailAttrList[key]);
					var isflag = true;
					keys.forEach((ele) => {
					  if(ele == attr.attr) isflag = false;
					});
					if(isflag) {
					  detailAttrList[attr.attr] = attr.value;
					}
				  }
				} 
			});
			// console.log(detailAttrList);
	 //    return;
			var input_param = Base64.encode(
				JSON.stringify(
				  Object.keys(head_attr).map((a) => ({
					attr: a,
					value: head_attr[a] || "",
				  }))
				)
			);
			var jsonlist=[];
			detailAttrList.forEach(attr=>{
				jsonlist.push({
				  id:attr["id"]|| "",
				  attrs: Object.keys(attr).map((a) => ({
					attr: a,
					value: attr[a] || "",
				  })).filter((a)=>{return a.attr != "id"})
				});
			});
			const list = []
			list.push({page_name:$this.param.Sub_Page[1].Name,item_list:jsonlist,ext_data:$this.detail2ExtData})
			
			// console.log(jsonlist);
			$this.runCustomEvent(event,input_param,list,'2');
		},

		onPanelClick(value) {
			// console.log(value);
			this.active_id = '';
			this.activelist.forEach(ele => {
				ele.active = false;
			});
			this.activelist[value].active = true;
			// console.log(this.$data.activelist);
		},
		//确定
		ok() {
			this.Before_OK_Event = this.param.Sub_Page[0].Before_ok;
			this.After_OK_Event = this.param.Sub_Page[0].After_ok;
			// console.log(this.Before_OK_Event);
			// console.log(this.After_OK_Event);
			if (this.$data.Before_OK_Event.ID) //是否有确定前事件
				this.sava(this.$data.Before_OK_Event);
			else if (this.$data.After_OK_Event.ID) //是否有确定后事件
				this.sava(this.$data.After_OK_Event);
		},
		sava(event) {
			var $this = this;
			if (this.$data.detail1StyleDefList.length == 0) {
				uni.showModal({
					title: "提示",
					content: "没有正在码盘的数据！",
					showCancel: false,
					confirmText: "取消"
				});
				return false;
			}
			//获取表头属性
			var head_attr = {};
			this.$data.head_styledef.form.items.forEach(item => {
				head_attr[item.fieldId] = item.value;
			});
			// console.log(head_attr);
			//获取正在码盘属性
			var detailAttrList = [];
			this.$data.detail1StyleDefList.forEach(style => {
				var detail_attr = {};
				style.form.items.forEach(item => {
					if (item.name == "Layout") { //判断是否是栅栏格式
						item.setting.colList.forEach(cols => {
							if (cols != null) detail_attr[cols.fieldId] = cols.value;
						});
					} else
						detail_attr[item.fieldId] = item.value;
				});

				detail_attr['id'] = style.form.objId;
				if ($this.param.Sub_Page[0].Select_Button == true) { //判断选择按钮是否为true
					if (style.SelBut_Checked == true)
						detailAttrList.push(detail_attr);
				} else
					detailAttrList.push(detail_attr);
			});
			// console.log(detailAttrList);
			//获取正在码盘里没有显示的字段
			this.$data.detail1StyleDefList.forEach(style => {
				style.form.attrs.forEach(attr => {
					for (var key in detailAttrList) {
						if (style.form.objId == detailAttrList[key]['id']) {
							var keys = Object.keys(detailAttrList[key]);
							var isflag = true;
							keys.forEach((ele) => {
								if (ele == attr.attr) isflag = false;
							});
							if (isflag) {
								detailAttrList[attr.attr] = attr.value;
							}
						}
					}
				});
			});
			// console.log(detailAttrList);
			//    return;
			var input_param = Base64.encode(
				JSON.stringify(
					Object.keys(head_attr).map((a) => ({
						attr: a,
						value: head_attr[a] || "",
					}))
				)
			);
			var jsonlist = [];
			detailAttrList.forEach(attr => {
				jsonlist.push({
					 id:attr["id"]|| "",
					attrs: Object.keys(attr).map((a) => ({
						attr: a,
						value: attr[a] || "",
					}))
				});
			});
			const list = []
			list.push({page_name:$this.param.Sub_Page[0].Name,item_list:jsonlist,ext_data:$this.detail1ExtData})
			// console.log(jsonlist);
			$this.runCustomEvent(event, input_param, list, '1');
			// jsonlist.forEach(async (json,key)=>{
			// 	await $this.runCustomEvent(event,input_param,json,'1');
			// });
		},
		ok2() {
			this.Before_OK_Event = this.param.Sub_Page[1].Before_ok;
			this.After_OK_Event = this.param.Sub_Page[1].After_ok;
			// console.log(this.Before_OK_Event);
			// console.log(this.After_OK_Event);
			if (this.$data.Before_OK_Event.ID) //是否有确定前事件
				this.sava2(this.$data.Before_OK_Event);
			else if (this.$data.After_OK_Event.ID) //是否有确定后事件
				this.sava2(this.$data.After_OK_Event);
		},
		sava2(event) {
			var $this = this;
			if (this.$data.detail2StyleDefList.length == 0) {
				uni.showModal({
					title: "提示",
					content: "没有已码盘的数据！",
					showCancel: false,
					confirmText: "取消"
				});
				return false;
			}
			//获取表头属性
			var head_attr = {};
			this.$data.head_styledef.form.items.forEach(item => {
				head_attr[item.fieldId] = item.value;
			});
			// console.log(head_attr);
			//获取正在码盘属性
			var detailAttrList = [];
			this.$data.detail2StyleDefList.forEach(style => {
				var detail_attr = {};
				style.form.items.forEach(item => {
					if (item.name == "Layout") { //判断是否是栅栏格式
						item.setting.colList.forEach(cols => {
							if (cols != null) detail_attr[cols.fieldId] = cols.value;
						});
					} else
						detail_attr[item.fieldId] = item.value;
				});

				detail_attr['id'] = style.form.objId;
				if ($this.param.Sub_Page[1].Select_Button == true) { //判断选择按钮是否为true
					if (style.SelBut_Checked == true)
						detailAttrList.push(detail_attr);
				} else
					detailAttrList.push(detail_attr);
			});
			// console.log(detailAttrList);
			//获取正在码盘里没有显示的字段
			this.$data.detail2StyleDefList.forEach(style => {
				style.form.attrs.forEach(attr => {
					for (var key in detailAttrList) {
						if (style.form.objId == detailAttrList[key]['id']) {
							var keys = Object.keys(detailAttrList[key]);
							var isflag = true;
							keys.forEach((ele) => {
								if (ele == attr.attr) isflag = false;
							});
							if (isflag) {
								detailAttrList[attr.attr] = attr.value;
							}
						}
					}
				});
			});
			// console.log(detailAttrList);
			//    return;
			var input_param = Base64.encode(
				JSON.stringify(
					Object.keys(head_attr).map((a) => ({
						attr: a,
						value: head_attr[a] || "",
					}))
				)
			);
			var jsonlist = [];
			detailAttrList.forEach(attr => {
				jsonlist.push({
					 id:attr["id"]|| "",
					attrs: Object.keys(attr).map((a) => ({
						attr: a,
						value: attr[a] || "",
					}))
				});
			});
			const list = []
			list.push({page_name:$this.param.Sub_Page[1].Name,item_list:jsonlist,ext_data:$this.detail2ExtData})
			
			// console.log(jsonlist);
			$this.runCustomEvent(event, input_param, list, '2');
			// jsonlist.forEach(async (json,key)=>{
			// 	await $this.runCustomEvent(event,input_param,json,'2');
			// });
		},
		//执行确定脚本
		async runCustomEvent(event, input_param, json, type) {
			var $this = this;
			var data_json = Base64.encode(
				JSON.stringify(json)
			);
			var dataInfo = {
				ed_type: 0,
				start_transaction: true,
				class_id: this.$data.ClsID,
				class_name: '',
				event_id: event.ID,
				event_name: '',
				data_obj_id: '',
				obj_attr: '',
				prj_id: '',
				ref_cls_id: '',
				rel_obj_id: '',
				user_login: '',
				data_json: data_json,
				compose_info: '',
				ext_info: '',
				global_attr: '',
				input_param: input_param,
			};
			
			// console.log(dataInfo);
			this.$store.dispatch('runCustomEvent', dataInfo).then(res => {
				console.log(res);
				if (res.err_code == 0) {
					var result = res.result;
					if (result.ret != 0) {
						var tip = result.err_info ? typeof result.err_info == 'string' ? result.err_info :
							result.err_info.join('<br/>') : '';
						if (result.ret == 801) uni.showModal({
							title: '提示',
							content: tip,
							showCancel: false,
							confirmText: "取消"
						});
						else uni.showModal({
							title: '提示',
							content: tip + ',提示:' + result.ret,
							showCancel: false,
							confirmText: "取消"
						});
						return false;
					} else {
						var tip = result.info ? typeof result.info == 'string' ? result.info : result.info
							.join('<br/>') : '';
						if (tip) uni.showModal({
							title: '提示',
							content: tip,
							showCancel: false,
							confirmText: "取消"
						});
						if (result.result_type == 0) {
							if (result.action) {
							//	uni.showModal({title:"提示",content:JSON.stringify(result.action),showCancel:false,confirmText:"取消"});
								
								result.action.forEach(item => {
									if (item.action_type == "insert_subtable_page_row") { //码盘中
										var value = item.value;
										//加载已经码盘数据
										$this.viewAceionRow(value, 'add');
										//清空条码内容
										$this.$data.head_styledef.form.items.forEach((item,
											index) => {
												if (item.fieldId != "S_CNTR_CODE") {
													item.value = '';
													item.oldvalue = '';
													$this.$data.head_styledef.form.model[item
														.fieldId] = '';
												}
											});
										//清除正在码盘中成功的数据
										// $this.$data.detail1StyleDefList.forEach((style,index)=>{
										//   if(style.form.items[0].fieldId == json.attrs[0].attr && style.form.items[0].value == json.attrs[0].value){ 
										// 	$this.$data.detail1StyleDefList.splice(index,1);
										// 	return;
										//   }
										// });
										// this.detail2StyleDefList=[];
										uni.showModal({
											title: "提示",
											content: "码盘成功",
											showCancel: false,
											confirmText: "取消"
										});
										//  } else if(item.action_type == "refresh"){  //刷新
										//    var value = item.value;
										// //刷新当前页面
										// // location.reload();
										// uni.redirectTo({
										// 	url:'../modal/5600?param='+JSON.stringify(this.$data.param)+"&titlename="+this.$data.title
										// });
										//  } else if(item.action_type == "prompt"){  //打开系统提示弹框
										//    var value = '';
										// item.value.forEach(ele=>{
										// 	if(value) value+='\n';
										// 	value+=ele;
										// });
										// uni.showModal({title:"系统提示",content:value,showCancel:false,confirmText:"关闭"});
									}
									else if(item.action_type == "remove_subtable_page_row"){  //清除面板中指定id的数据
										var value = item.value;
										if(value.page_name == $this.param.Sub_Page[0].Name){ //判断返回的action的page_name是否是待分拣
											//清除面板中指定id的数据
											value.row.forEach(row=>{
												$this.$data.detail1StyleDefList.forEach((ele,index)=>{
													if(ele.form.objId == row.id){
													  $this.$data.detail1StyleDefList.splice(index,1); 
													}
												});
											});
										}
									} 
																			
									else if (item.action_type == "set_subtable_page_row") {
										$this.viewActionSetRow( item.value)
										
									} else if (item.action_type == "set_subtable_page_ext_data") {
										var value = item.value;
										if (value.page_name == $this.$data.param.Sub_Page[0].Name) { //判断返回的action的page_name是否是待分拣
											$this.setData({detail1ExtData:value.ext_data})
										} else if (value.page_name == $this.$data.param.Sub_Page[1].Name) {
											$this.setData({detail2ExtData:value.ext_data})
										}
									}
									else if (item.action_type == "clear_subpage_rows") {
										var value = item.value;
										if (value.page_name == $this.$data.param.Sub_Page[0].Name) { //判断返回的action的page_name是否是待分拣
											$this.setData({detail1StyleDefList:[],detail1ExtData:{}})
										} else if (value.page_name == $this.$data.param.Sub_Page[1].Name) {
											$this.setData({detail2StyleDefList:[],detail2ExtData:{}})
										}
									}
									else if (item.action_type == "set_dlg_current_edit_attr") {
										if($this.focusOldFieldId == item.value)
											$this.setData({focusFieldId: ""})
										else{
											$this.setData({focusFieldId:$this.focusOldFieldId})	
										}
										$this.$nextTick(()=> {
											$this.setData({focusFieldId:item.value})
										});
									}
								});
							} else {
								if ($this.$data.After_OK_Event.ID != event.ID) { //判断当前事件是否是确定后事件
									if (type == '1') {
										$this.sava($this.$data.After_OK_Event); //执行确定后事件
									} else {
										$this.sava2($this.$data.After_OK_Event); //执行确定后事件
									}
								}
							}
						} else {
							// $this.$data.detail2StyleDefList=[];
							if (result.info) {
								uni.showModal({
									title: "提示",
									content: result.info,
									showCancel: false,
									confirmText: "取消"
								});
							}
						}
					}
				} else {
					uni.showModal({
						title: "错误8",
						content: res.err_msg,
						showCancel: false,
						confirmText: "取消"
					});
				}
			}).catch(ex => {
				var tip = typeof ex == "string" ? ex : ex.errMsg;
				uni.showModal({
					title: "错误8.1",
					content: "执行“确定后”事件失败：" + tip,
					showCancel: false,
					confirmText: "取消"
				});
			});
		},

		cancel(e) { //取消
			uni.navigateBack({
				delta: 1 //返回层数，2则上上页
			});
		},
	},
};
</script>

<style  lang="scss">
.uni-page-modal-5600{
	
	display: flex;
	height: 100vh;
	width: 750rpx;
	flex-direction: column !important;
	.view-header{
		display: flex;
		width: 100%;
		flex-direction: column;
		margin-top: 15rpx;
	}
	.v-headStyle{
		width: 100%;
	}
	.view-content{
		display:flex;
		flex: 1;
		width: 100%;
		flex-direction: column;
		min-height: 100px;
	}
	.dv-tab {
		width: calc(100% - 30rpx);
		padding:0 15rpx;
	}
	.view-tabpage {
		width: 100%;
		flex: 1;
	}
	
	.view-tab-content{
		display:flex;
		flex: 1;
		width: calc(100% - 30rpx);
		padding:10rpx 15rpx;
		flex-direction: column;
		overflow-y: auto;
		
	}
	.uni-panel-content {
		display: flex;
		width: 100%;
		height: 100%;
		flex-direction: column !important;
	}
	.view-bottom{
		display:flex;
		flex-direction:row;
		width: calc(100% - 30rpx);
		padding:10rpx 15rpx 30rpx 15rpx;
	}
	.v-headStyle .txt_title {
		font-size: 34rpx;
		text-align: right;
		display: inline-block;
		vertical-align: 12px;
	}

	.v-headStyle input {
		display: inline-block;
		width: 85%;
		height: 52rpx;
		line-height: 34rpx;
		background: #FFF;
		border-radius: 0 !important;
		color: #2d8cf0;
		padding: 10rpx 8rpx 12rpx;
		font-size: 34rpx;
		font-family: inherit;
		box-shadow: none !important;
		transition-duration: 0.1s;
		margin-top: 4rpx;
	}

	.v-headStyle input::-webkit-input-placeholder {
		font-size: 12rpx;
	}

	.input-wrapper {
		border: 1px solid #d5d5d5;
		display: inline-block;
		width: 65%;
		line-height: 22rpx;
	}

	[nvue] uni-view {
		position: relative;
		border: 0 solid #000;
		box-sizing: border-box;
	}

	.uni-input {
		/* border: none; */
	}

	.uni-icon {
		/* border: 1px solid red; */
		width: 8%;
		font-family: uniicons;
		font-size: 40rpx;
		font-weight: 400;
		font-style: normal;
		/* width: 48rpx; */
		height: 48rpx;
		line-height: 48rpx;
		color: #2d8cf0;
		cursor: pointer;
		display: inline-block;
		vertical-align: 18rpx;
	}

	.dv-panel {
		background-color: #efefef;
		padding: 20rpx 20rpx 4rpx 0px;
		border-radius: 12rpx;
		margin: 10rpx 0 20rpx 0;
		text-align: right;
		/* border: 1px solid red; */
	}

	.dv-panel-input {
		width: 100%;
		display: inline-block;
		text-align: left;
	}

	.dv-panel-input .dv-input {
		margin-bottom: 2rpx;
	}

	.dv-panel .txt_title {
		font-size: 34rpx;
		text-align: right;
		display: inline-block;
	}

	.dv-panel input {
		vertical-align: middle;
		display: inline-block;
		border: 1px solid #d5d5d5;
		width: 68%;
		height: 52rpx;
		line-height: 34rpx;
		background: #FFF;
		border-radius: 7px !important;
		color: #2d8cf0;
		padding: 6rpx 8rpx 8rpx;
		font-size: 32rpx;
		font-family: inherit;
		box-shadow: none !important;
		transition-duration: 0.1s;
		margin-top: 0rpx;
	}

	.dv-panel input::-webkit-input-placeholder {
		font-size: 10rpx;
	}

	.dv-panel .form-item-span {
		vertical-align: text-top;
		color: #2d8cf0;
		white-space: normal;
		word-break: break-all;
		display: inline-block;
		width: calc(100% - 100px);
	}

	.dv-panel-button {
		/* display: inline-block;
	margin-right: 20rpx; */
		width: 100%;
		text-align: left;
		padding-bottom: 20rpx;
	}

	.dv-panel-button checkbox-group {
		padding-left: 20px;
		display: inline-block;
	}

	.dv-panel-button button {
		text-align: left;
		line-height: 1.8;
		border: none;
		font-size: 34rpx;
		width: 180rpx;
		display: inline-block;
		float: right;
		text-align: center;
	}

	button.btn_cancel {
		width: 49.5%;
		padding: 20rpx;
		line-height: 1.5;
		border: none;
		font-size: 38rpx;
		font-weight: bold;
		float: left;
		display: inline-block;
	}

	button.btn_add {
		width: 49.5%;

		padding: 20rpx;
		line-height: 1.5;
		border: none;
		font-size: 38rpx;
		font-weight: bold;
		float: right;
		display: inline-block;
	}

	.logo {
		height: 100rpx;
		width: 460rpx;
		display: flex;
		margin: 38% auto;
	}

	.dv-border {
		border: 1px solid red;
	}

	.view-imagetext {
		text-align: center;
		width: calc(100% - 80rpx);
		padding: 20rpx 40rpx 0px 40rpx;
		height:calc(100% - 30rpx);
		overflow: hidden;
	}

	.view-imagetext .view-imagetext-uploadlist {
		padding: 30rpx 0px 10rpx 0px;
		vertical-align: middle;
		display: inline-block;
		width: 100%;
		height: 100%;
		text-align: center;
		line-height: 100%;
		border: 2rpx solid transparent;
		border-radius: 8rpx;
		overflow: hidden;
		background: #fff;
		position: relative;
		/* box-shadow: 0 2rpx 2rpx rgba(0, 0, 0, 0.2);
  margin-right: 8rpx; */
	}

	.view-imagetext .txt-text {
		display: block;
		margin: 20rpx;
		font-weight: bold;
	}

	.view-detalist-centen {
		text-align: center;
		width: 100%;
	}

	.view-detalist-centen .txt-detalist {
		background: #94D5EF;
		display: block;
		width: 100%;
		font-size: 36rpx;
		line-height: 80rpx;
		font-weight: 500;
	}

	.panel-active {
		border: 2px solid red;
	}

	.bk-active {
		background-color: #D6FCB2;
	}

	.dv_select {
		display: inline-block;
		width: 66%;
		background: #FFF;
		border-radius: 0 !important;
		color: #2d8cf0;
		/* padding: 10rpx 8rpx 12rpx; */
		font-size: 34rpx;
		font-family: inherit;
		box-shadow: none !important;
		transition-duration: 0.1s;
		margin-top: 0rpx;
		vertical-align: 20rpx;
	}

	.dv_select .uni-select {
		border: 2rpx solid #ccc;
		border-radius: 0 !important;
		color: #2d8cf0;
	}

	.dv_select .uni-select__input-text {
		color: #2d8cf0;
	}

	.input-disabled {
		background-color: #f3f3f3 !important;
	}

	.demo-uni-row {
		margin-bottom: 0px;
		display: block;
	}

	::v-deep .uni-row {
		margin-bottom: 0px;
	}

	.view-tabpage ::v-deep .uni-row {
		margin-bottom: 5px;
	}

	.demo-uni-col {
		height: 36px;
		border-radius: 5px;
	}

	.demo-uni-row .uni-input {
		width: calc(100% - 120px);
	}
	
	
}
</style>
